<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Class: NucleusController</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <link rel="stylesheet" href=".././rdoc-style.css" type="text/css" media="screen" />
  <script type="text/javascript">
  // <![CDATA[

  function popupCode( url ) {
    window.open(url, "Code", "resizable=yes,scrollbars=yes,toolbar=no,status=no,height=150,width=400")
  }

  function toggleCode( id ) {
    if ( document.getElementById )
      elem = document.getElementById( id );
    else if ( document.all )
      elem = eval( "document.all." + id );
    else
      return false;

    elemStyle = elem.style;
    
    if ( elemStyle.display != "block" ) {
      elemStyle.display = "block"
    } else {
      elemStyle.display = "none"
    }

    return true;
  }
  
  // Make codeblocks hidden by default
  document.writeln( "<style type=\"text/css\">div.method-source-code { display: none }</style>" )
  
  // ]]>
  </script>

</head>
<body>



    <div id="classHeader">
        <table class="header-table">
        <tr class="top-aligned-row">
          <td><strong>Class</strong></td>
          <td class="class-name-in-header">NucleusController</td>
        </tr>
        <tr class="top-aligned-row">
            <td><strong>In:</strong></td>
            <td>
                <a href="../files/app/controllers/nucleus_controller_rb.html">
                app/controllers/nucleus_controller.rb
                </a>
        <br />
            </td>
        </tr>

        <tr class="top-aligned-row">
            <td><strong>Parent:</strong></td>
            <td>
                <a href="ApplicationController.html">
                ApplicationController
               </a>
            </td>
        </tr>
        </table>
    </div>
  <!-- banner header -->

  <div id="bodyContent">



  <div id="contextContent">



   </div>

    <div id="method-list">
      <h3 class="section-bar">Methods</h3>

      <div class="name-list">
      <a href="#M000039">create</a>&nbsp;&nbsp;
      <a href="#M000042">destroy</a>&nbsp;&nbsp;
      <a href="#M000037">index</a>&nbsp;&nbsp;
      <a href="#M000038">poll</a>&nbsp;&nbsp;
      <a href="#M000040">start</a>&nbsp;&nbsp;
      <a href="#M000041">stop</a>&nbsp;&nbsp;
      </div>
    </div>

  </div>


    <!-- if includes -->

    <div id="section">





      


    <!-- if method_list -->
    <div id="methods">
      <h3 class="section-bar">Public Instance methods</h3>

      <div id="method-M000039" class="method-detail">
        <a name="M000039"></a>

        <div class="method-heading">
          <a href="#M000039" class="method-signature">
          <span class="method-name">create</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000039-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000039-source">
<pre>
    <span class="ruby-comment cmt"># File app/controllers/nucleus_controller.rb, line 17</span>
17:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">create</span>
18:     <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">params</span>[<span class="ruby-value str">'template'</span>].<span class="ruby-identifier">nil?</span>
19:       <span class="ruby-identifier">process_error</span>(<span class="ruby-value str">&quot;You haven&amp;rsquo;t selected a template to create&quot;</span>)
20:     <span class="ruby-keyword kw">else</span>
21: 
22:       <span class="ruby-identifier">template</span> = 
23:         <span class="ruby-constant">OpenvzTemplate</span>.<span class="ruby-identifier">find</span>(<span class="ruby-identifier">:first</span>,
24:                             <span class="ruby-identifier">:conditions</span> =<span class="ruby-operator">&gt;</span> [<span class="ruby-value str">&quot;path = ?&quot;</span>, <span class="ruby-identifier">params</span>[<span class="ruby-value str">'template'</span>]])
25: 
26:       <span class="ruby-comment cmt"># Security: Checking that template_path is in the database.</span>
27:       <span class="ruby-identifier">raise</span> <span class="ruby-constant">TemplateDoesNotExistError</span>,
28:       <span class="ruby-node">&quot;Invalid Template: #{template_path} doesn't exist in database.&quot;</span> <span class="ruby-keyword kw">if</span> 
29:         <span class="ruby-identifier">template</span>.<span class="ruby-identifier">nil?</span>
30: 
31:       <span class="ruby-identifier">ve</span> = <span class="ruby-constant">VirtualEnvironment</span>.<span class="ruby-identifier">new</span>
32:     
33:       <span class="ruby-constant">VirtualEnvironment</span>.<span class="ruby-identifier">transaction</span> <span class="ruby-keyword kw">do</span> 
34:         <span class="ruby-comment cmt"># Transactions exhibit the ACID properties</span>
35:         <span class="ruby-comment cmt"># And need to be used when there are multiple SQL statements</span>
36:         <span class="ruby-comment cmt"># that are doing all doing one thing</span>
37: 
38:         <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">uid</span> = <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:user_id</span>]     
39:         
40:         <span class="ruby-keyword kw">begin</span>
41:           <span class="ruby-comment cmt"># 1st SQL statement</span>
42:           <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">grab_available_veid</span>
43: 
44:         <span class="ruby-keyword kw">rescue</span> 
45:           <span class="ruby-identifier">err_msg</span> = <span class="ruby-value str">'No more VMs can be created. Please destroy one or more.'</span>
46:           <span class="ruby-identifier">flash</span>[<span class="ruby-identifier">:notices</span>] <span class="ruby-operator">||=</span> []
47:           <span class="ruby-identifier">flash</span>[<span class="ruby-identifier">:notices</span>] <span class="ruby-operator">&lt;&lt;</span> <span class="ruby-identifier">err_msg</span>
48:           
49:         <span class="ruby-keyword kw">else</span>
50:           <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">template_id</span> = <span class="ruby-identifier">template</span>.<span class="ruby-identifier">id</span>
51:           <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">status</span> = <span class="ruby-value str">'creating'</span>
52:           <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">updated_on</span> = <span class="ruby-constant">Time</span>.<span class="ruby-identifier">now</span>
53:           <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">ip</span> = <span class="ruby-keyword kw">nil</span>      
54:         
55:           <span class="ruby-comment cmt"># 2nd SQL statement</span>
56:           <span class="ruby-identifier">old_ve</span> = <span class="ruby-constant">VirtualEnvironment</span>. 
57:             <span class="ruby-identifier">find_by_veid_and_uid_and_status</span>(<span class="ruby-identifier">ve</span>.<span class="ruby-identifier">veid</span>, <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">uid</span>, <span class="ruby-value str">'destroyed'</span>)
58: 
59:           <span class="ruby-comment cmt"># 3rd SQL statement</span>
60:           <span class="ruby-constant">VirtualEnvironment</span>.<span class="ruby-identifier">destroy</span>(<span class="ruby-identifier">old_ve</span>.<span class="ruby-identifier">id</span>) <span class="ruby-keyword kw">unless</span>
61:             <span class="ruby-identifier">old_ve</span>.<span class="ruby-identifier">nil?</span> 
62: 
63:           <span class="ruby-comment cmt"># 4th SQL statement</span>
64:           <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">save!</span> 
65:           
66:           <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>] <span class="ruby-operator">||=</span> {}
67:           <span class="ruby-keyword kw">begin</span>
68:             <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>][<span class="ruby-identifier">ve</span>.<span class="ruby-identifier">veid</span>] = 
69:               <span class="ruby-constant">Nucleus</span>.<span class="ruby-identifier">new</span>.<span class="ruby-identifier">create</span>(<span class="ruby-identifier">params</span>[<span class="ruby-value str">'template'</span>], <span class="ruby-identifier">ve</span>.<span class="ruby-identifier">veid</span>)   
70:           <span class="ruby-keyword kw">rescue</span> <span class="ruby-constant">TemplateDoesNotExistError</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-identifier">msg</span>
71:             <span class="ruby-identifier">process_error</span>(<span class="ruby-identifier">msg</span>)
72:           <span class="ruby-keyword kw">end</span>
73:         <span class="ruby-keyword kw">end</span>
74:       <span class="ruby-keyword kw">end</span>
75:     <span class="ruby-keyword kw">end</span>
76: 
77:     <span class="ruby-identifier">redirect_to</span> <span class="ruby-identifier">:controller</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'cytoskeleton'</span>, <span class="ruby-identifier">:action</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'areas'</span>
78:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000042" class="method-detail">
        <a name="M000042"></a>

        <div class="method-heading">
          <a href="#M000042" class="method-signature">
          <span class="method-name">destroy</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000042-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000042-source">
<pre>
     <span class="ruby-comment cmt"># File app/controllers/nucleus_controller.rb, line 105</span>
105:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">destroy</span>
106:     <span class="ruby-identifier">veid</span> = <span class="ruby-ivar">@params</span>[<span class="ruby-identifier">:id</span>]
107: 
108:     <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">veid</span>.<span class="ruby-identifier">nil?</span>
109:       <span class="ruby-identifier">process_error</span>(<span class="ruby-value str">&quot;You haven&amp;rsquo;t selected a VM to destroy&quot;</span>)
110: 
111:     <span class="ruby-keyword kw">else</span>
112:       <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>] <span class="ruby-operator">||=</span> {}
113:       <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>][<span class="ruby-identifier">veid</span>] = <span class="ruby-constant">Nucleus</span>.<span class="ruby-identifier">new</span>.<span class="ruby-identifier">destroy</span>(<span class="ruby-identifier">veid</span>)
114:     <span class="ruby-keyword kw">end</span>
115: 
116:     <span class="ruby-identifier">redirect_to</span> <span class="ruby-identifier">:controller</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'cytoskeleton'</span>, <span class="ruby-identifier">:action</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'areas'</span>
117:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000037" class="method-detail">
        <a name="M000037"></a>

        <div class="method-heading">
          <a href="#M000037" class="method-signature">
          <span class="method-name">index</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000037-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000037-source">
<pre>
   <span class="ruby-comment cmt"># File app/controllers/nucleus_controller.rb, line 3</span>
3:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">index</span>
4:     <span class="ruby-identifier">raise</span> <span class="ruby-value str">'Nucleus is expecting params[:button]. But no value was passed.'</span> <span class="ruby-keyword kw">if</span> 
5:       <span class="ruby-identifier">params</span>[<span class="ruby-identifier">:button</span>].<span class="ruby-identifier">nil?</span>
6:     
7:     <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">method</span>(<span class="ruby-identifier">params</span>[<span class="ruby-identifier">:button</span>].<span class="ruby-identifier">underscore</span>).<span class="ruby-identifier">call</span>
8:     
9:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000038" class="method-detail">
        <a name="M000038"></a>

        <div class="method-heading">
          <a href="#M000038" class="method-signature">
          <span class="method-name">poll</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000038-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000038-source">
<pre>
    <span class="ruby-comment cmt"># File app/controllers/nucleus_controller.rb, line 11</span>
11:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">poll</span>
12:     <span class="ruby-comment cmt"># Exposes the private method of ApplicationController</span>
13:     <span class="ruby-keyword kw">super</span>
14:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000040" class="method-detail">
        <a name="M000040"></a>

        <div class="method-heading">
          <a href="#M000040" class="method-signature">
          <span class="method-name">start</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000040-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000040-source">
<pre>
    <span class="ruby-comment cmt"># File app/controllers/nucleus_controller.rb, line 80</span>
80:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">start</span>
81:     <span class="ruby-identifier">veid</span> = <span class="ruby-ivar">@params</span>[<span class="ruby-identifier">:id</span>]
82:     
83:     <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">veid</span>.<span class="ruby-identifier">nil?</span>
84:       <span class="ruby-identifier">process_error</span>(<span class="ruby-value str">&quot;You haven&amp;rsquo;t selected a VM to start&quot;</span>)
85:     <span class="ruby-keyword kw">else</span>
86:       <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>] <span class="ruby-operator">||=</span> {}
87:       <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>][<span class="ruby-identifier">veid</span>] = <span class="ruby-constant">Nucleus</span>.<span class="ruby-identifier">new</span>.<span class="ruby-identifier">start</span>(<span class="ruby-identifier">veid</span>)
88:     <span class="ruby-keyword kw">end</span>
89: 
90:     <span class="ruby-identifier">redirect_to</span> <span class="ruby-identifier">:controller</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'cytoskeleton'</span>, <span class="ruby-identifier">:action</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'areas'</span>
91:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000041" class="method-detail">
        <a name="M000041"></a>

        <div class="method-heading">
          <a href="#M000041" class="method-signature">
          <span class="method-name">stop</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000041-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000041-source">
<pre>
     <span class="ruby-comment cmt"># File app/controllers/nucleus_controller.rb, line 93</span>
 93:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">stop</span>      
 94:     <span class="ruby-identifier">veid</span> = <span class="ruby-ivar">@params</span>[<span class="ruby-identifier">:id</span>]
 95:     <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">veid</span>.<span class="ruby-identifier">nil?</span>
 96:       <span class="ruby-identifier">process_error</span>(<span class="ruby-value str">&quot;You haven&amp;rsquo;t selected a VM to stop&quot;</span>)
 97:     <span class="ruby-keyword kw">else</span>
 98:       <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>] <span class="ruby-operator">||=</span> {}
 99:       <span class="ruby-identifier">session</span>[<span class="ruby-identifier">:workers</span>][<span class="ruby-identifier">veid</span>] = <span class="ruby-constant">Nucleus</span>.<span class="ruby-identifier">new</span>.<span class="ruby-identifier">stop</span>(<span class="ruby-identifier">veid</span>)
100:     <span class="ruby-keyword kw">end</span>
101: 
102:     <span class="ruby-identifier">redirect_to</span> <span class="ruby-identifier">:controller</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'cytoskeleton'</span>, <span class="ruby-identifier">:action</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'areas'</span>
103:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>


    </div>


  </div>


<div id="validator-badges">
  <p><small><a href="http://validator.w3.org/check/referer">[Validate]</a></small></p>
</div>

</body>
</html>